from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.utils.json_processor import JSONProcessor
from cpl_query.extension import List

from bot_core.configuration.file_logging_settings import FileLoggingSettings


class BotLoggingSettings(ConfigurationModelABC):
    def __init__(self, **kwargs: dict):
        ConfigurationModelABC.__init__(self)
        self._files: List[FileLoggingSettings] = List(FileLoggingSettings)

        if kwargs is not None:
            self._files_from_dict(kwargs)

    @property
    def files(self) -> List[FileLoggingSettings]:
        return self._files

    def _files_from_dict(self, settings: dict):
        files = List(FileLoggingSettings)
        for s in settings:
            settings[s]["Key"] = s
            files.append(JSONProcessor.process(FileLoggingSettings, settings[s]))
        self._files = files
