from abc import ABC, abstractmethod

from cpl_query.extension import List

from bot_data.model.user_game_ident import UserGameIdent


class UserGameIdentRepositoryABC(ABC):
    @abstractmethod
    def __init__(self):
        pass

    @abstractmethod
    def get_user_game_idents(self) -> List[UserGameIdent]:
        pass

    @abstractmethod
    def get_user_game_idents_by_game_server_id(self, id: int) -> List[UserGameIdent]:
        pass

    @abstractmethod
    def get_user_game_ident_by_id(self, id: int) -> UserGameIdent:
        pass

    @abstractmethod
    def get_user_game_ident_by_ident(self, ident: str) -> UserGameIdent:
        pass

    @abstractmethod
    def find_user_game_ident_by_ident(self, ident: str) -> UserGameIdent:
        pass

    @abstractmethod
    def get_user_game_idents_by_user_id(self, user_id: int) -> List[UserGameIdent]:
        pass

    @abstractmethod
    def add_user_game_ident(self, user_game_ident: UserGameIdent):
        pass

    @abstractmethod
    def update_user_game_ident(self, user_game_ident: UserGameIdent):
        pass

    @abstractmethod
    def delete_user_game_ident(self, user_game_ident: UserGameIdent):
        pass

    @abstractmethod
    def delete_user_game_ident_by_user_id(self, user_id: int):
        pass
