from datetime import datetime

from cpl_core.database import TableABC


class TechnicianIdConfig(TableABC):
    def __init__(
        self,
        technician_id: str,
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._id = id
        self._technician_id = technician_id

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def id(self) -> int:
        return self._id

    @property
    def technician_id(self) -> str:
        return self._technician_id

    @technician_id.setter
    def technician_id(self, value: str):
        self._technician_id = value

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
                SELECT * FROM `CFG_TechnicianIds`;
            """
        )

    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(
            f"""
                SELECT * FROM `CFG_TechnicianIds`
                WHERE `Id` = {id};
            """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
                INSERT INTO `CFG_TechnicianIds` (
                    `TechnicianId`
                ) VALUES (
                    '{self._technician_id}'
                );
            """
        )

    @property
    def udpate_string(self) -> str:
        return str(
            f"""
                UPDATE `CFG_TechnicianIds`
                SET `TechnicianId` = '{self._technician_id}'
                WHERE `Id` = {self._id};
            """
        )

    @property
    def delete_string(self) -> str:
        return str(
            f"""
                DELETE FROM `CFG_TechnicianIds`
                WHERE `TechnicianId` = {self._technician_id};
            """
        )
