import { DataWithHistory } from "./data.model";
import { Level, LevelFilter } from "./level.model";
import { Server, ServerFilter } from "./server.model";
import { UserJoinedServer } from "./user_joined_server.model";
import { UserJoinedVoiceChannel } from "./user_joined_voice_channel.model";
import { UserJoinedGameServer } from "./user_joined_game_server.model";
import { Achievement } from "./achievement.model";
import { UserWarning } from "./user_warning.model";

export interface User extends DataWithHistory {
  id?: number;
  discordId?: number;
  name?: string;
  xp?: number;
  messageCount?: number;
  reactionCount?: number;
  birthday?: string;
  ontime?: number;
  level?: Level;
  server?: Server;
  leftServer?: boolean;

  joinedServerCount?: number;
  joinedServers?: UserJoinedServer[];

  joinedVoiceChannelCount?: number;
  joinedVoiceChannels?: UserJoinedVoiceChannel[];

  userJoinedGameServerCount?: number;
  userJoinedGameServers?: UserJoinedGameServer[];

  achievementCount?: number;
  achievements?: Achievement[];

  userWarningCount?: number;
  userWarnings?: UserWarning[];
}

export interface UserFilter {
  id?: number;
  discordId?: number;
  name?: string;
  xp?: number;
  ontime?: number;
  level?: LevelFilter;
  server?: ServerFilter;
  leftServer?: boolean;
}
