import { Component, OnInit } from "@angular/core";
import { ConfigListComponent } from "../config-list/config-list.component";
import { Table } from "primeng/table";
import { PossibleFeatureFlagsQuery } from "../../../../models/graphql/query.model";
import { DataService } from "../../../../services/data/data.service";

@Component({
  selector: "app-feature-flag-list",
  templateUrl: "./feature-flag-list.component.html",
  styleUrls: ["./feature-flag-list.component.scss"]
})
export class FeatureFlagListComponent extends ConfigListComponent implements OnInit {
  featureFlags: string[] = [];


  constructor(
    private dataService: DataService
  ) {
    super();
  }

  ngOnInit() {
    this.dataService.query<PossibleFeatureFlagsQuery>("{possibleFeatureFlags}"
    ).subscribe(data => {
      this.featureFlags = data.possibleFeatureFlags;
    });
  }

  override addNew(table: Table) {
    const id = this.internal_data.length == 0 ? 1 : Math.max.apply(Math, this.internal_data.map(value => {
      return value.id ?? 0;
    })) + 1;
    const newItem = { id: id, value: { key: "", value: false } };
    this.internal_data.push(newItem);

    table.initRowEdit(newItem);
    const index = this.internal_data.findIndex(l => l.id == newItem.id);
    this.editInit(newItem, index);
  }
}
