import { Injectable } from '@angular/core';
import { ConfirmationService } from 'primeng/api';
import { ConfirmationDialog } from 'src/app/models/utils/confirmation-dialog';

@Injectable({
  providedIn: 'root'
})
export class ConfirmationDialogService {

  constructor(
    private confirmationService: ConfirmationService
  ) { }

  errorDialog(header: string, message: string) {
    this.confirmationService.confirm({
      key: 'errorConfirmationDialog',
      header: header,
      message: message
    });
  }

  confirmDialog(header: string, message: string, accept?: () => void, reject?: () => void) {
    let options: ConfirmationDialog = {
      key: 'confirmConfirmationDialog',
      header: header,
      message: message
    };

    if (accept) {
      options.accept = accept;
    }

    if (reject) {
      options.reject = reject;
    }

    this.confirmationService.confirm(options);
  }

  warningDialog(header: string, message: string, accept?: () => void) {
    let options: ConfirmationDialog = {
      key: 'warningConfirmationDialog',
      header: header,
      message: message
    };

    if (accept) {
      options.accept = accept;
    }

    this.confirmationService.confirm(options);
  }
}
